#include <io.h>
#include <sirc.h>


#define sirc_error sirc_cnt=0    // .  

unsigned char   sirc_t  =0;      //  
unsigned char   sirc_cnt=0;      //-  
//0    -  . (      )
//1    -   .
//2-8  -  CMD.
//9-13 -  ADDR.
//13   -   ! 

unsigned int    sirc_data=0;

 // External Interrupt 1 service routine
interrupt [EXT_INT1] void ext_int1_isr(void)
{                 
  if(MCUCR & 0x04){             //(0->1)    
    tc0_disbl;
    if(sirc_cnt>0){             //body   
      sirc_data = sirc_data >> 1;            //      

      sirc_addr = sirc_addr | ((sirc_t == 2)<<4);

      sirc_cnt++;               //-   +1
    }                           //end Body
    if (sirc_t==4){             //  (4T)...
      sirc_addr=0x00;           //... ,...      
      sirc_cmd =0x00;           // ...   
      sirc_cnt =1;              //   . . sirc_cnt
    }                           //end 4T  
    else{                       //   
      if ((sirc_t != 2) && (sirc_t != 1))
        sirc_error; 
    }                           // end 4T else
    if (sirc_cnt==13){          // !!!
     sirc_cmd  = sirc_cmd >> 1; //      
     sirc_addr = sirc_addr | 0x80;
    } 
  }                             //end (0->1)
  else{                         //(1->0)
    tc0_reload;                 // 
    tc0_enbl;
  } //else 
  int1_disbl;  
  MCUCR^=0x04;                  //  
  int1_enbl;  
  sirc_t=0;                     // .  ! :-)
}//EXT_INT1

interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{ 
  tc0_reload;               //  
  sirc_t++;                 //    
}//TIM0_OVF
